%
% Status : main Dynare file
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

if isoctave || matlab_ver_less_than('8.6')
    clear all
else
    clearvars -global
    clear_persistent_variables(fileparts(which('dynare')), false)
end
tic0 = tic;
% Define global variables.
global M_ options_ oo_ estim_params_ bayestopt_ dataset_ dataset_info estimation_info ys0_ ex0_
options_ = [];
M_.fname = 'hs_dynarecode';
M_.dynare_version = '4.6.4';
oo_.dynare_version = '4.6.4';
options_.dynare_version = '4.6.4';
%
% Some global variables initialization
%
global_initialization;
diary off;
diary('hs_dynarecode.log');
M_.exo_names = cell(3,1);
M_.exo_names_tex = cell(3,1);
M_.exo_names_long = cell(3,1);
M_.exo_names(1) = {'epsR'};
M_.exo_names_tex(1) = {'epsR'};
M_.exo_names_long(1) = {'epsR'};
M_.exo_names(2) = {'epsz'};
M_.exo_names_tex(2) = {'epsz'};
M_.exo_names_long(2) = {'epsz'};
M_.exo_names(3) = {'epsg'};
M_.exo_names_tex(3) = {'epsg'};
M_.exo_names_long(3) = {'epsg'};
M_.endo_names = cell(8,1);
M_.endo_names_tex = cell(8,1);
M_.endo_names_long = cell(8,1);
M_.endo_names(1) = {'y'};
M_.endo_names_tex(1) = {'y'};
M_.endo_names_long(1) = {'y'};
M_.endo_names(2) = {'R'};
M_.endo_names_tex(2) = {'R'};
M_.endo_names_long(2) = {'R'};
M_.endo_names(3) = {'pi'};
M_.endo_names_tex(3) = {'pi'};
M_.endo_names_long(3) = {'pi'};
M_.endo_names(4) = {'z'};
M_.endo_names_tex(4) = {'z'};
M_.endo_names_long(4) = {'z'};
M_.endo_names(5) = {'g'};
M_.endo_names_tex(5) = {'g'};
M_.endo_names_long(5) = {'g'};
M_.endo_names(6) = {'gdp'};
M_.endo_names_tex(6) = {'gdp'};
M_.endo_names_long(6) = {'gdp'};
M_.endo_names(7) = {'infl'};
M_.endo_names_tex(7) = {'infl'};
M_.endo_names_long(7) = {'infl'};
M_.endo_names(8) = {'interest'};
M_.endo_names_tex(8) = {'interest'};
M_.endo_names_long(8) = {'interest'};
M_.endo_partitions = struct();
M_.param_names = cell(11,1);
M_.param_names_tex = cell(11,1);
M_.param_names_long = cell(11,1);
M_.param_names(1) = {'tau'};
M_.param_names_tex(1) = {'tau'};
M_.param_names_long(1) = {'tau'};
M_.param_names(2) = {'beta'};
M_.param_names_tex(2) = {'beta'};
M_.param_names_long(2) = {'beta'};
M_.param_names(3) = {'kappa'};
M_.param_names_tex(3) = {'kappa'};
M_.param_names_long(3) = {'kappa'};
M_.param_names(4) = {'psi1'};
M_.param_names_tex(4) = {'psi1'};
M_.param_names_long(4) = {'psi1'};
M_.param_names(5) = {'psi2'};
M_.param_names_tex(5) = {'psi2'};
M_.param_names_long(5) = {'psi2'};
M_.param_names(6) = {'rho_r'};
M_.param_names_tex(6) = {'rho\_r'};
M_.param_names_long(6) = {'rho_r'};
M_.param_names(7) = {'rho_z'};
M_.param_names_tex(7) = {'rho\_z'};
M_.param_names_long(7) = {'rho_z'};
M_.param_names(8) = {'rho_g'};
M_.param_names_tex(8) = {'rho\_g'};
M_.param_names_long(8) = {'rho_g'};
M_.param_names(9) = {'data_gamma'};
M_.param_names_tex(9) = {'data\_gamma'};
M_.param_names_long(9) = {'data_gamma'};
M_.param_names(10) = {'data_pi'};
M_.param_names_tex(10) = {'data\_pi'};
M_.param_names_long(10) = {'data_pi'};
M_.param_names(11) = {'data_r'};
M_.param_names_tex(11) = {'data\_r'};
M_.param_names_long(11) = {'data_r'};
M_.param_partitions = struct();
M_.exo_det_nbr = 0;
M_.exo_nbr = 3;
M_.endo_nbr = 8;
M_.param_nbr = 11;
M_.orig_endo_nbr = 8;
M_.aux_vars = [];
options_.varobs = cell(3, 1);
options_.varobs(1)  = {'gdp'};
options_.varobs(2)  = {'infl'};
options_.varobs(3)  = {'interest'};
options_.varobs_id = [ 6 7 8  ];
M_.Sigma_e = zeros(3, 3);
M_.Correlation_matrix = eye(3, 3);
M_.H = 0;
M_.Correlation_matrix_ME = 1;
M_.sigma_e_is_diagonal = true;
M_.det_shocks = [];
options_.linear = true;
options_.block = false;
options_.bytecode = false;
options_.use_dll = false;
options_.linear_decomposition = false;
M_.nonzero_hessian_eqs = [];
M_.hessian_eq_zero = isempty(M_.nonzero_hessian_eqs);
M_.orig_eq_nbr = 8;
M_.eq_nbr = 8;
M_.ramsey_eq_nbr = 0;
M_.set_auxiliary_variables = exist(['./+' M_.fname '/set_auxiliary_variables.m'], 'file') == 2;
M_.epilogue_names = {};
M_.epilogue_var_list_ = {};
M_.orig_maximum_endo_lag = 1;
M_.orig_maximum_endo_lead = 1;
M_.orig_maximum_exo_lag = 0;
M_.orig_maximum_exo_lead = 0;
M_.orig_maximum_exo_det_lag = 0;
M_.orig_maximum_exo_det_lead = 0;
M_.orig_maximum_lag = 1;
M_.orig_maximum_lead = 1;
M_.orig_maximum_lag_with_diffs_expanded = 1;
M_.lead_lag_incidence = [
 1 5 13;
 2 6 0;
 0 7 14;
 3 8 15;
 4 9 16;
 0 10 0;
 0 11 0;
 0 12 0;]';
M_.nstatic = 3;
M_.nfwrd   = 1;
M_.npred   = 1;
M_.nboth   = 3;
M_.nsfwrd   = 4;
M_.nspred   = 4;
M_.ndynamic   = 5;
M_.dynamic_tmp_nbr = [0; 0; 0; 0; ];
M_.model_local_variables_dynamic_tt_idxs = {
};
M_.equations_tags = {
  1 , 'name' , 'y' ;
  2 , 'name' , 'pi' ;
  3 , 'name' , 'R' ;
  4 , 'name' , 'z' ;
  5 , 'name' , 'g' ;
  6 , 'name' , 'gdp' ;
  7 , 'name' , 'infl' ;
  8 , 'name' , 'interest' ;
};
M_.mapping.y.eqidx = [1 2 3 6 ];
M_.mapping.R.eqidx = [1 3 8 ];
M_.mapping.pi.eqidx = [1 2 3 7 ];
M_.mapping.z.eqidx = [1 4 6 ];
M_.mapping.g.eqidx = [1 2 3 5 ];
M_.mapping.gdp.eqidx = [6 ];
M_.mapping.infl.eqidx = [7 ];
M_.mapping.interest.eqidx = [8 ];
M_.mapping.epsR.eqidx = [3 ];
M_.mapping.epsz.eqidx = [4 ];
M_.mapping.epsg.eqidx = [5 ];
M_.static_and_dynamic_models_differ = false;
M_.has_external_function = false;
M_.state_var = [1 2 4 5 ];
M_.exo_names_orig_ord = [1:3];
M_.maximum_lag = 1;
M_.maximum_lead = 1;
M_.maximum_endo_lag = 1;
M_.maximum_endo_lead = 1;
oo_.steady_state = zeros(8, 1);
M_.maximum_exo_lag = 0;
M_.maximum_exo_lead = 0;
oo_.exo_steady_state = zeros(3, 1);
M_.params = NaN(11, 1);
M_.endo_trends = struct('deflator', cell(8, 1), 'log_deflator', cell(8, 1), 'growth_factor', cell(8, 1), 'log_growth_factor', cell(8, 1));
M_.NNZDerivatives = [31; 0; -1; ];
M_.static_tmp_nbr = [0; 0; 0; 0; ];
M_.model_local_variables_static_tt_idxs = {
};
M_.params(1) = 2.83;
tau = M_.params(1);
M_.params(3) = 0.78;
kappa = M_.params(3);
M_.params(4) = 1.8;
psi1 = M_.params(4);
M_.params(5) = 0.63;
psi2 = M_.params(5);
M_.params(6) = 0.77;
rho_r = M_.params(6);
M_.params(7) = 0.88;
rho_z = M_.params(7);
M_.params(8) = 0.98;
rho_g = M_.params(8);
M_.params(9) = 0.52;
data_gamma = M_.params(9);
M_.params(10) = 3.3;
data_pi = M_.params(10);
M_.params(11) = 0.42;
data_r = M_.params(11);
M_.params(2) = 1/(1+M_.params(11)/400);
beta = M_.params(2);
%
% SHOCKS instructions
%
M_.exo_det_length = 0;
M_.Sigma_e(1, 1) = (0.22)^2;
M_.Sigma_e(2, 2) = (0.31)^2;
M_.Sigma_e(3, 3) = (0.71)^2;
estim_params_.var_exo = zeros(0, 10);
estim_params_.var_endo = zeros(0, 10);
estim_params_.corrx = zeros(0, 11);
estim_params_.corrn = zeros(0, 11);
estim_params_.param_vals = zeros(0, 10);
estim_params_.param_vals = [estim_params_.param_vals; 1, 2.83, 1, 5, 2, 2, 0.5, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 3, 0.78, 0.2, 1, 5, NaN, NaN, 0, 1, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 4, 1.8, 1, 3, 2, 1.5, 0.25, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 5, 0.63, 0.1, 2, 2, 0.5, 0.25, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 6, 0.77, 0.4, 0.9, 5, NaN, NaN, 0, 1, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 8, 0.98, 0.7, 0.999, 5, NaN, NaN, 0, 1, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 7, 0.88, 0.7, 0.99, 5, NaN, NaN, 0, 1, NaN ];
estim_params_.var_exo = [estim_params_.var_exo; 1, 0.22, 0.1, 0.4, 4, 0.5013256549262002, 0.2620545510248134, NaN, NaN, NaN ];
estim_params_.var_exo = [estim_params_.var_exo; 3, 0.71, 0.3, 0.99, 4, 1.2533141373155003, 0.6551363775620335, NaN, NaN, NaN ];
estim_params_.var_exo = [estim_params_.var_exo; 2, 0.31, 0.01, 0.5, 4, 0.6266570686577502, 0.32756818878101673, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 11, 0.42, 0.2, 0.8, 2, 0.5, 0.5, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 10, 3.3, 2.5, 4, 2, 7, 2, NaN, NaN, NaN ];
estim_params_.param_vals = [estim_params_.param_vals; 9, 0.52, 0.04, 0.95, 3, 0.4, 0.2, NaN, NaN, NaN ];
options_.irf = 100;
options_.nograph = true;
var_list_ = {};
[info, oo_, options_, M_] = stoch_simul(M_, options_, oo_, var_list_);
options_.mh_replic = 0;
options_.mode_compute = 1;
options_.nograph = true;
options_.datafile = 'Bayes_hs_data_mat';
options_.optim_opt = '''MaxIter'',200';
options_.order = 1;
var_list_ = {};
oo_recursive_=dynare_estimation(var_list_);
save('hs_dynarecode_results.mat', 'oo_', 'M_', 'options_');
if exist('estim_params_', 'var') == 1
  save('hs_dynarecode_results.mat', 'estim_params_', '-append');
end
if exist('bayestopt_', 'var') == 1
  save('hs_dynarecode_results.mat', 'bayestopt_', '-append');
end
if exist('dataset_', 'var') == 1
  save('hs_dynarecode_results.mat', 'dataset_', '-append');
end
if exist('estimation_info', 'var') == 1
  save('hs_dynarecode_results.mat', 'estimation_info', '-append');
end
if exist('dataset_info', 'var') == 1
  save('hs_dynarecode_results.mat', 'dataset_info', '-append');
end
if exist('oo_recursive_', 'var') == 1
  save('hs_dynarecode_results.mat', 'oo_recursive_', '-append');
end


disp(['Total computing time : ' dynsec2hms(toc(tic0)) ]);
if ~isempty(lastwarn)
  disp('Note: warning(s) encountered in MATLAB/Octave code')
end
diary off
