
var labobs robs pinfobs dy dc dinve dw zcapf rkf kf pkf cf invef yf labf wf rrf mc zcap rk k pk c inve y lab pinf w r a b g qs ms spinf sw kpf kp;  
varexo ea eb eg  eqs  em  epinf ew;  
parameters curvw curvp constelab constepinf constebeta calfa 
czcap csadjcost ctou csigma chabb ccs cinvs cfc 
cindw cprobw cindp cprobp csigl clandaw 
crdpi crpi crdy cry crr 
crhoa  crhob crhog  crhoqs crhoms crhopinf crhow cmaw cmap
ctrend cg;   

// Fixed parameters
ctou=     .025;
clandaw=  1.5;
cg=       0.18;
curvp=    10;
curvw=    10;
calfa=    0.197;
csigma=   1.321;
cfc=      1.77;
cgy=      0;
csadjcost=6.556;
chabb=    0.804;    
cprobw=   0.765;
csigl=    2.45;
cprobp=   0.518;
cindw=    0.536;
cindp=    0.174;
czcap=    0.401;
crpi=     1.866;
crr=      0.875;
cry=      0.12;
crdy=     0.125;
constepinf=0.635;
constebeta=0.114;
constelab= 1.743;
ctrend=    0.509;

// estimated parameters initialisation
crhoa=    0.9845;
crhob=    0.1575;
crhog=    0.9724;
crhoqs=   0.6284;
crhoms=   0.2407;
crhopinf= 0.9845;
crhow=    0.9801;
cmap=     0.8035;
cmaw=     0.9452;

model(linear); 

@#include "sw_stst.mod"

// flexible economy

	      0*(1-calfa)*a + 1*a =  calfa*rkf+(1-calfa)*(wf)  ;
	      zcapf =  (1/(czcap/(1-czcap)))* rkf  ;
	      rkf =  (wf)+labf-kf ;
	      kf =  kpf(-1)+zcapf ;
	      invef = (1/(1+cbetabar*cgamma))* (  invef(-1) + cbetabar*cgamma*invef(1)+(1/(cgamma^2*csadjcost))*pkf ) +qs ;
          pkf = -rrf-0*b+(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b +(crk/(crk+(1-ctou)))*rkf(1) +  ((1-ctou)/(crk+(1-ctou)))*pkf(1) ;
	      cf = (chabb/cgamma)/(1+chabb/cgamma)*cf(-1) + (1/(1+chabb/cgamma))*cf(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(labf-labf(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(rrf+0*b) + b ;
	      yf = ccy*cf+ciy*invef+g  +  crkky*zcapf ;
	      yf = cfc*( calfa*kf+(1-calfa)*labf +a );
	      wf = csigl*labf 	+(1/(1-chabb/cgamma))*cf - (chabb/cgamma)/(1-chabb/cgamma)*cf(-1) ;
	      kpf =  (1-cikbar)*kpf(-1)+(cikbar)*invef + (cikbar)*(cgamma^2*csadjcost)*qs ;

// sticky price - wage economy

	      mc =  calfa*rk+(1-calfa)*(w) - 1*a - 0*(1-calfa)*a ;
	      zcap =  (1/(czcap/(1-czcap)))* rk ;
	      rk =  w+lab-k ;
	      k =  kp(-1)+zcap ;
	      inve = (1/(1+cbetabar*cgamma))* (  inve(-1) + cbetabar*cgamma*inve(1)+(1/(cgamma^2*csadjcost))*pk ) +qs ;
          pk = -r+pinf(1)-0*b +(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b + (crk/(crk+(1-ctou)))*rk(1) +  ((1-ctou)/(crk+(1-ctou)))*pk(1) ;
	      c = (chabb/cgamma)/(1+chabb/cgamma)*c(-1) + (1/(1+chabb/cgamma))*c(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(lab-lab(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(r-pinf(+1) + 0*b) +b ;
	      y = ccy*c+ciy*inve+g  +  1*crkky*zcap ;
	      y = cfc*( calfa*k+(1-calfa)*lab +a );
	      pinf =  (1/(1+cbetabar*cgamma*cindp)) * ( cbetabar*cgamma*pinf(1) +cindp*pinf(-1) 
               +((1-cprobp)*(1-cbetabar*cgamma*cprobp)/cprobp)/((cfc-1)*curvp+1)*(mc)  )  + spinf ; 
	      w =  (1/(1+cbetabar*cgamma))*w(-1)
               +(cbetabar*cgamma/(1+cbetabar*cgamma))*w(1)
               +(cindw/(1+cbetabar*cgamma))*pinf(-1)
               -(1+cbetabar*cgamma*cindw)/(1+cbetabar*cgamma)*pinf
               +(cbetabar*cgamma)/(1+cbetabar*cgamma)*pinf(1)
               +(1-cprobw)*(1-cbetabar*cgamma*cprobw)/((1+cbetabar*cgamma)*cprobw)*(1/((clandaw-1)*curvw+1))*
               (csigl*lab + (1/(1-chabb/cgamma))*c - ((chabb/cgamma)/(1-chabb/cgamma))*c(-1) -w) 
               + 1*sw ;
	      r =  crpi*(1-crr)*pinf
               +cry*(1-crr)*(y-yf)     
               +crdy*(y-yf-y(-1)+yf(-1))
               +crr*r(-1)
               +ms  ;
	      a = crhoa*a(-1)  + ea;
	      b = crhob*b(-1) + eb;
	      g = crhog*(g(-1)) + eg;
	      qs = crhoqs*qs(-1) + eqs;
	      ms = crhoms*ms(-1) + em;
          spinf = crhopinf*spinf(-1) + epinf - cmap*epinf(-1);
	      sw = crhow*sw(-1) + ew - cmaw*ew(-1) ;
	      kp =  (1-cikbar)*kp(-1)+cikbar*inve + cikbar*cgamma^2*csadjcost*qs ;

// measurment equations

          dy=y-y(-1)+ctrend;
          dc=c-c(-1)+ctrend;
          dinve=inve-inve(-1)+ctrend;
          dw=w-w(-1)+ctrend;
          pinfobs = 1*(pinf) + constepinf;
          robs =    1*(r) + conster;
          labobs = lab + constelab;

end; 

shocks;
var ea;
stderr 0.4903;
var eb;
stderr 0.3505;
var eg;
stderr 0.7359;
var eqs;
stderr 0.5667;
var em;
stderr 0.2332;
var epinf;
stderr 0.2308;
var ew;
stderr 0.2644;
end;

estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
stderr ea,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr eb,0.4,0.025,5,INV_GAMMA_PDF,0.1,2;
stderr eg,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr eqs,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr em,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr epinf,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr ew,0.4,0.01,3,INV_GAMMA_PDF,0.1,2;
crhoa,.8 ,.01,.9999,BETA_PDF,0.5,0.20;
crhob,.8,.01,.9999,BETA_PDF,0.5,0.20;
crhog,.8,.01,.9999,BETA_PDF,0.5,0.20;
crhoqs,.8,.01,.9999,BETA_PDF,0.5,0.20;
crhoms,.8,.01,.9999,BETA_PDF,0.5,0.20;
crhopinf,.8,.01,.9999,BETA_PDF,0.5,0.20;
crhow,.8,.01,.9999,BETA_PDF,0.5,0.20;
cmap,.8,0.01,.9999,BETA_PDF,0.5,0.20;
cmaw,.8,0.01,.9999,BETA_PDF,0.5,0.20;
end;

varobs dy dc dinve labobs pinfobs dw robs;

// Compute irfs with pre-defined parameters
stoch_simul(irf=50, nograph);

// Estimate shock parameters
estimation(optim=('MaxIter',200),datafile=data_sw,mode_compute=1,mh_replic=0,nograph);
