
% Your dynare path
addpath C://dynare//4.6.4//matlab

% Compute IRF (with pre-defined parameters) and estimate model
dynare sw_dynarecode.mod 

% Store IRFs to compare with sequence jacobian on python
save('irf_dynare.mat', 'y_ea', 'y_eb', 'y_eg', 'y_eqs', 'y_em', 'y_epinf', 'y_ew', ...
    'c_ea', 'c_eb', 'c_eg', 'c_eqs', 'c_em', 'c_epinf', 'c_ew', ...
    'inve_ea', 'inve_eb', 'inve_eg', 'inve_eqs', 'inve_em', 'inve_epinf', 'inve_ew',  ...
    'lab_ea', 'lab_eb', 'lab_eg', 'lab_eqs', 'lab_em', 'lab_epinf', 'lab_ew', ...
    'pinf_ea', 'pinf_eb', 'pinf_eg', 'pinf_eqs', 'pinf_em', 'pinf_epinf', 'pinf_ew', ...
    'w_ea', 'w_eb', 'w_eg', 'w_eqs', 'w_em', 'w_epinf', 'w_ew', ...
    'r_ea', 'r_eb', 'r_eg', 'r_eqs', 'r_em', 'r_epinf', 'r_ew');