function g1 = static_g1(T, y, x, params, T_flag)
% function g1 = static_g1(T, y, x, params, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%                                              to evaluate the model
%   T_flag    boolean                 boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   g1
%

if T_flag
    T = sw_dynarecode.static_g1_tt(T, y, x, params);
end
g1 = zeros(40, 40);
g1(1,9)=(-params(6));
g1(1,16)=(-(1-params(6)));
g1(1,30)=1;
g1(2,8)=1;
g1(2,9)=(-T(8));
g1(3,9)=1;
g1(3,10)=1;
g1(3,15)=(-1);
g1(3,16)=(-1);
g1(4,8)=(-1);
g1(4,10)=1;
g1(4,37)=(-1);
g1(5,11)=(-(T(10)*1/T(12)));
g1(5,33)=(-1);
g1(6,9)=(-((T(4)-(1-params(9)))/T(4)));
g1(6,11)=1-(1-params(9))/T(4);
g1(6,17)=1;
g1(6,31)=(-(1/T(14)));
g1(7,12)=T(18);
g1(7,17)=T(14);
g1(7,31)=(-1);
g1(8,8)=(-((T(4)-(1-params(9)))*T(6)));
g1(8,12)=(-(1-params(36)-T(7)));
g1(8,13)=(-T(7));
g1(8,14)=1;
g1(8,32)=(-1);
g1(9,10)=(-(params(14)*params(6)));
g1(9,14)=1;
g1(9,15)=(-(params(14)*(1-params(6))));
g1(9,30)=(-params(14));
g1(10,12)=(-T(19));
g1(10,15)=(-params(19));
g1(10,16)=1;
g1(11,13)=(-T(5));
g1(11,33)=(-(T(5)*T(12)));
g1(11,37)=1-(1-T(5));
g1(12,18)=1;
g1(12,20)=(-params(6));
g1(12,28)=(-(1-params(6)));
g1(12,30)=1;
g1(13,19)=1;
g1(13,20)=(-T(8));
g1(14,20)=1;
g1(14,21)=1;
g1(14,26)=(-1);
g1(14,28)=(-1);
g1(15,19)=(-1);
g1(15,21)=1;
g1(15,38)=(-1);
g1(16,22)=(-(T(10)*1/T(12)));
g1(16,33)=(-1);
g1(17,20)=(-((T(4)-(1-params(9)))/T(4)));
g1(17,22)=1-(1-params(9))/T(4);
g1(17,27)=(-1);
g1(17,29)=1;
g1(17,31)=(-(1/T(14)));
g1(18,23)=T(18);
g1(18,27)=(-T(14));
g1(18,29)=T(14);
g1(18,31)=(-1);
g1(19,19)=(-((T(4)-(1-params(9)))*T(6)));
g1(19,23)=(-(1-params(36)-T(7)));
g1(19,24)=(-T(7));
g1(19,25)=1;
g1(19,32)=(-1);
g1(20,21)=(-(params(14)*params(6)));
g1(20,25)=1;
g1(20,26)=(-(params(14)*(1-params(6))));
g1(20,30)=(-params(14));
g1(21,18)=(-(1/(1+T(9)*params(17))*T(15)));
g1(21,27)=1-1/(1+T(9)*params(17))*(T(9)+params(17));
g1(21,35)=(-1);
g1(22,23)=(-(T(17)*T(19)));
g1(22,26)=(-(params(19)*T(17)));
g1(22,27)=(-(T(16)+params(15)/(1+T(9))-(1+T(9)*params(15))/(1+T(9))));
g1(22,28)=1-(T(10)+T(16)-T(17));
g1(22,36)=(-1);
g1(23,14)=(1-params(25))*params(24);
g1(23,25)=(-((1-params(25))*params(24)));
g1(23,27)=(-(params(22)*(1-params(25))));
g1(23,29)=1-params(25);
g1(23,34)=(-1);
g1(24,30)=1-params(26);
g1(25,31)=1-params(27);
g1(26,32)=1-params(28);
g1(27,33)=1-params(29);
g1(28,34)=1-params(30);
g1(29,35)=1-params(31);
g1(30,36)=1-params(32);
g1(31,24)=(-T(5));
g1(31,33)=(-(params(8)*T(5)*T(11)));
g1(31,38)=1-(1-T(5));
g1(32,4)=1;
g1(33,5)=1;
g1(34,6)=1;
g1(35,7)=1;
g1(36,3)=1;
g1(36,27)=(-1);
g1(37,2)=1;
g1(37,29)=(-1);
g1(38,1)=1;
g1(38,26)=(-1);
g1(39,39)=1;
g1(40,40)=1;
if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
end
end
