function T = static_resid_tt(T, y, x, params)
% function T = static_resid_tt(T, y, x, params)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T         [#temp variables by 1]  double   vector of temporary terms to be filled by function
%   y         [M_.endo_nbr by 1]      double   vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1]       double   vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1]     double   vector of parameter values in declaration order
%
% Output:
%   T         [#temp variables by 1]  double   vector of temporary terms
%

assert(length(T) >= 17);

T(1) = 1+params(35)/100;
T(2) = 1/(1+params(5)/100);
T(3) = T(2)*T(1)^(-params(10));
T(4) = T(2)^(-1)*T(1)^params(10);
T(5) = 1-(1-params(9))/T(1);
T(6) = params(14)*((1-params(6))/params(6)*(T(4)-(1-params(9)))/(params(6)^params(6)*(1-params(6))^(1-params(6))/(params(14)*(T(4)-(1-params(9)))^params(6)))^(1/(1-params(6))))^(params(6)-1);
T(7) = T(1)*T(5)*T(6);
T(8) = 1/(params(7)/(1-params(7)));
T(9) = T(1)*T(3);
T(10) = 1/(1+T(9));
T(11) = T(1)^2;
T(12) = params(8)*T(11);
T(13) = params(11)/T(1);
T(14) = (1-T(13))/(params(10)*(1+T(13)));
T(15) = (1-params(18))*(1-T(9)*params(18))/params(18)/(1+(params(14)-1)*params(2));
T(16) = T(9)/(1+T(9));
T(17) = 1/(1+(params(20)-1)*params(1))*(1-params(16))*(1-T(9)*params(16))/((1+T(9))*params(16));

end
